=== debian/changelog ===
wlmaker (0.6.2+git20251211+ds-1) experimental; urgency=medium

  * New upstream version. (Closes: #1121292)
  * d/control: add libxdg-basedir-dev to build-depends.

 -- Alex Myczko <tar@debian.org>  Thu, 11 Dec 2025 22:37:02 +0000
