=== debian/changelog ===
wlmaker (0.7-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Thu, 25 Dec 2025 14:37:39 +0000
