=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

%:
	dh $@

override_dh_install:
	dh_install
	cp debian/GNUstep.plist debian/wlmaker/etc/xdg/wlmaker/Themes/Default.plist
#	rm debian/wlmaker/usr/bin/wrap-wlmaker.sh
#	rm debian/wlmaker/usr/share/wlmaker.desktop
#	rm debian/wlmaker/usr/share/wlmclock.desktop
#	mkdir -p debian/wlmaker/usr/share/applications
#	mv debian/wlmaker/usr/share/wlmclock.desktop debian/wlmaker/usr/share/applications/wlmclock.desktop

override_dh_auto_test:
	@echo no thanks
