=== debian/changelog ===
wlmaker (0.7+git20260116+ds-1) experimental; urgency=medium

  * New upstream version.
  * d/control: drop wmaker from Depends.
  * d/copyright: bump years.

 -- Alex Myczko <tar@debian.org>  Fri, 16 Jan 2026 19:28:28 +0100
