=== debian/watch ===
Version: 5

Template: Github
Owner: phkaeser
Project: wlmaker
