=== src/toolkit/CMakeLists.txt ===
--- 
+++ 
@@ -30,6 +30,7 @@
   layer.h
   menu.h
   menu_item.h
+  output_tracker.h
   panel.h
   popup.h
   primitives.h
@@ -67,6 +68,7 @@
   layer.c
   menu.c
   menu_item.c
+  output_tracker.c
   panel.c
   popup.c
   primitives.c
