=== debian/changelog ===
wlmaker (0.7+git20260201+ds-1) experimental; urgency=medium

  * New upstream version with cherry picked patches.

 -- Alex Myczko <tar@debian.org>  Sun, 01 Feb 2026 14:55:07 +0100
